/**
 * ./src/classes/families/mockup.ts
 * penguins-eggs v.10.0.0 / ecmascript 2020
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
/**
 * Mockup
 * @remarks all the utilities
 */
export default class Mockup {
    /**
     * Mockup: calamaresInstall
     */
    static calamaresInstall(verbose?: boolean): Promise<void>;
    /**
     * Mockup: calamaresPolicies
     */
    static calamaresPolicies(): Promise<void>;
    /**
     * Mockup: calamaresRemove
     */
    static calamaresRemove(verbose?: boolean): Promise<boolean>;
    /**
     * Mockup: isInstalledWayland
     * @returns true if wayland is installed
     */
    static isInstalledWayland(): boolean;
    /**
     * Mockup: isInstalledXorg
     * @returns true if xorg is installed
     */
    static isInstalledXorg(): boolean;
    /**
     * Mockup: packageInstall
     * Install the package packageName
     * @param packageName {string}
     * @returns {boolean} True if success
     */
    static packageInstall(packageName: string): Promise<boolean>;
    /**
     * Mockup: packageIsInstalled
     * restuisce VERO se il pacchetto è installato
     * @param packageName
     */
    static packageIsInstalled(packageName: string): boolean;
    /**
     * Mockup: packagePacmanAvailable
     * restuisce VERO se il pacchetto è installato
     * @param packageName
     */
    static packagePacmanAvailable(packageName: string): Promise<boolean>;
    /**
     * Mockup: packagePacmanLast
     * @param packageName
     * @returns
     */
    static packagePacmanLast(packageName: string): Promise<string>;
}
