/**
 * ./src/classes/incubation/fisherman.ts
 * penguins-eggs v.10.0.0 / ecmascript 2020
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
import { IDistro, IInstaller } from '../../interfaces/index.js';
export default class Fisherman {
    distro: IDistro;
    installer: IInstaller;
    verbose: boolean;
    constructor(distro: IDistro, installer: IInstaller, verbose?: boolean);
    /**
     *
     * @param name
     * @param isScript
     */
    buildCalamaresModule(name: string, isScript?: boolean, theme?: string): Promise<string>;
    /**
     *
     * @param name
     */
    buildCalamaresPy(name: string): Promise<void>;
    /**
     *
     * @param name
     * @param replaces [['search','replace']]
     */
    buildModule(name: string, vendor?: string): Promise<void>;
    /**
     *
     * @param name
     */
    contextualprocess(name: string): Promise<void>;
    /**
     * write setting
     */
    createCalamaresSettings(theme?: string, isClone?: boolean): Promise<void>;
    /**
     * usa i moduli-ts
     */
    moduleDisplaymanager(): Promise<void>;
    /**
     * Al momento rimane con la vecchia configurazione
     */
    moduleFinished(): Promise<void>;
    /**
     * ====================================================================================
     * M O D U L E S
     * ====================================================================================
     */
    /**
     * usa i moduli-ts
     */
    modulePackages(distro: IDistro, release?: boolean): Promise<void>;
    /**
     * Al momento rimane con la vecchia configurazione
     */
    moduleRemoveuser(username: string): Promise<void>;
    /**
     * Al momento rimane con la vecchia configurazione
     */
    moduleUnpackfs(): Promise<void>;
    /**
     *
     * @param name
     */
    shellprocess(name: string): Promise<void>;
    /**
     *
     * @param module
     * @param type
     * @param path
     */
    show(name: string, type: string, path: string): void;
}
