/**
 * ./src/classes/incubation/incubator.ts
 * penguins-eggs v.10.0.0 / ecmascript 2020
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
import { IInstaller } from '../../interfaces/i-installer.js';
import { IDistro, IRemix } from '../../interfaces/index.js';
/**
 *
 */
export default class Incubator {
    distro: IDistro;
    installer: IInstaller;
    isClone: boolean;
    remix: IRemix;
    theme: string;
    user_opt: string;
    verbose: boolean;
    /**
     *
     * @param remix
     * @param distro
     * @param verbose
     */
    constructor(remix: IRemix, distro: IDistro, user_opt?: string, theme?: string, isClone?: boolean, verbose?: boolean);
    /**
     * config
     */
    config(release?: boolean): Promise<void>;
    /**
     *
     */
    private createBranding;
    /**
     *
     */
    private createInstallerDirs;
}
