/**
* ./src/classes/initrd.ts
* penguins-eggs v.10.0.0 / ecmascript 2020
* author: Piero Proietti
* email: piero.proietti@gmail.com
* license: MIT
*/
import { IInitrd } from '../interfaces/index.js';
/**
 * initrd
 * Controlla e rimuove, se necessario cryptroot, resume
 * cryptsetup
 */
export default class Initrd {
    compression: string;
    fsLive: string;
    initrdDest: string;
    initrdSrc: string;
    workDir: string;
    constructor(initrdSrc?: string, initrdDest?: string, fsLive?: string);
    /**
     * Check initrd for cryptroot, resume, cryptsetup.
     */
    check(): IInitrd;
    /**
     * clean
     */
    clean(): void;
    /**
     * extract
     */
    extract(initrd?: string, verbose?: boolean): Promise<void>;
    /**
     * edit
     */
    private edit;
    /**
     * rebuild
     */
    private rebuild;
}
