/**
* ./src/classes/pxe.ts
* penguins-eggs v.10.0.0 / ecmascript 2020
* author: Piero Proietti
* email: piero.proietti@gmail.com
* license: MIT
*/
import { IDhcpOptions, ITftpOptions } from '../interfaces/i-pxe.js';
import Settings from './settings.js';
/**
* Pxe:
*/
export default class Pxe {
    bootLabel: string;
    echo: {};
    eggRoot: string;
    initrdImg: string;
    isos: string[];
    nest: string;
    pxeRoot: string;
    settings: Settings;
    verbose: boolean;
    vmlinuz: string;
    /**
     * configure PXE bios
     */
    bios(): Promise<void>;
    /**
     * build
     */
    build(): Promise<void>;
    /**
     *
     * @param dhcpOptions
     */
    dhcpStart(dhcpOptions: IDhcpOptions): void;
    /**
     * fertilization()
     *
     * cuckoo's nest
     */
    fertilization(): Promise<void>;
    /**
     * configure PXE http server
     */
    http(): Promise<void>;
    /**
    * start http server for images
    *
    */
    httpStart(): Promise<void>;
    /**
    *
    */
    ipxe(): Promise<void>;
    /**
     * start tftp
     */
    tftpStart(tftpOptions: ITftpOptions): Promise<void>;
    /**
     *
     * @param cmd
     */
    tryCatch(cmd?: string, echo?: boolean): Promise<void>;
}
