import { PJSON } from '../interfaces';
import { Plugin as IPlugin } from '../interfaces/plugin';
type PluginLoaderOptions = {
    plugins?: IPlugin[] | PluginsMap;
    root: string;
};
type LoadOpts = {
    dataDir: string;
    devPlugins?: boolean;
    force?: boolean;
    rootPlugin: IPlugin;
    userPlugins?: boolean;
    pluginAdditions?: {
        core?: string[];
        dev?: string[];
        path?: string;
    };
};
type PluginsMap = Map<string, IPlugin>;
export default class PluginLoader {
    options: PluginLoaderOptions;
    errors: (Error | string)[];
    plugins: PluginsMap;
    private pluginsProvided;
    constructor(options: PluginLoaderOptions);
    loadChildren(opts: LoadOpts): Promise<{
        errors: (Error | string)[];
        plugins: PluginsMap;
    }>;
    loadRoot({ pjson }: {
        pjson?: PJSON.Plugin;
    }): Promise<IPlugin>;
    private loadCorePlugins;
    private loadDevPlugins;
    private loadPlugins;
    private loadUserPlugins;
}
export {};
